/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var _Maybe = __webpack_require__(2);
	
	var test = (0, _Maybe.of)(5);

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.Do = exports.equals = exports.Nothing = exports.chain = exports.of = exports.map = exports.pempty = undefined;
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	exports.inj = inj;
	exports.prj = prj;
	exports.isNothing = isNothing;
	exports.isJust = isJust;
	exports.empty = empty;
	exports.getSemigroup = getSemigroup;
	exports.getMonoid = getMonoid;
	exports.ap = ap;
	exports.reduce = reduce;
	exports.alt = alt;
	exports.extend = extend;
	exports.getSetoid = getSetoid;
	exports.maybe = maybe;
	exports.fromMaybe = fromMaybe;
	exports.fromJust = fromJust;
	
	var _HKT = __webpack_require__(3);
	
	var _Identity = __webpack_require__(4);
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var IsMaybe = function IsMaybe() {
	  _classCallCheck(this, IsMaybe);
	};
	
	function inj(a) {
	  return a;
	}
	
	function prj(fa) {
	  return fa;
	}
	
	function isNothing(x) {
	  return x == Nothing;
	}
	
	function isJust(x) {
	  return x != Nothing;
	}
	
	function empty() {
	  return Nothing;
	}
	
	var pempty = exports.pempty = empty;
	
	function getSemigroup(semigroup) {
	  return {
	    concat: function concat(fx, fy) {
	      var x = prj(fx);
	      var y = prj(fy);
	      if (x == null) {
	        return fy;
	      }
	      if (y == null) {
	        return fx;
	      }
	      return _of(semigroup.concat(x, y));
	    }
	  };
	}
	
	function getMonoid(semigroup) {
	  return {
	    empty: empty,
	    concat: getSemigroup(semigroup).concat
	  };
	}
	
	function _map(f, fa) {
	  var a = prj(fa);
	  return a == null ? Nothing : inj(f(a));
	}
	
	exports.map = _map;
	function ap(fab, fa) {
	  var ab = prj(fab);
	  return ab == null ? Nothing : _map(ab, fa);
	}
	
	function _of(a) {
	  return inj(a);
	}
	
	exports.of = _of;
	function _chain(f, fa) {
	  return maybe(Nothing, f, fa);
	}
	
	exports.chain = _chain;
	var Nothing = exports.Nothing = inj(null);
	
	function reduce(f, a, fb) {
	  var b = prj(fb);
	  return b == null ? a : f(a, b);
	}
	
	function alt(fx, fy) {
	  return fx == Nothing ? fy : fx;
	}
	
	function extend(f, ea) {
	  return isNothing(ea) ? Nothing : inj(f(ea));
	}
	
	function _equals(setoid, fx, fy) {
	  var x = prj(fx);
	  var y = prj(fy);
	  if (x == null || y == null) {
	    return true;
	  }
	  if (x != null || y != null) {
	    return setoid.equals(x, y);
	  }
	  return false;
	}
	
	exports.equals = _equals;
	function getSetoid(setoid) {
	  return {
	    equals: function equals(fx, fy) {
	      return _equals(setoid, fx, fy);
	    }
	  };
	}
	
	function maybe(b, f, fa) {
	  return reduce(function (_, a) {
	    return f(a);
	  }, b, fa);
	}
	
	function fromMaybe(a, fa) {
	  return maybe(a, _Identity.id, fa);
	}
	
	function fromJust(fa) {
	  var a = prj(fa);
	  if (a == null) {
	    throw new Error('fromJust returned a Nothing');
	  }
	  return a;
	}
	
	/*
	
	  Do notation (experimental)
	
	  Example:
	
	  import * as maybe from '../Maybe'
	
	  const x: Maybe<number> = maybe.Do.of(3)
	    .map(n => n * 2)
	    .chain(n => maybe.of(n - 1))
	    .value
	
	*/
	
	var Do = exports.Do = function () {
	  _createClass(Do, null, [{
	    key: 'of',
	    value: function of(a) {
	      return new Do(_of(a));
	    }
	  }]);
	
	  function Do(value) {
	    _classCallCheck(this, Do);
	
	    this.value = value;
	  }
	
	  _createClass(Do, [{
	    key: 'map',
	    value: function map(f) {
	      return new Do(_map(f, this.value));
	    }
	  }, {
	    key: 'chain',
	    value: function chain(f) {
	      return new Do(_chain(f, this.value));
	    }
	  }]);
	
	  return Do;
	}();
	
	if (false) {
	  // eslint-disable-line
	  ({
	    map: _map,
	    ap: ap,
	    of: _of,
	    chain: _chain,
	    reduce: reduce,
	    alt: alt,
	    pempty: pempty,
	    extend: extend
	  });
	}

/***/ },
/* 3 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var HKT = exports.HKT = function HKT() {
	  _classCallCheck(this, HKT);
	}; // eslint-disable-line no-unused-vars

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.extract = exports.of = undefined;
	exports.id = id;
	exports.map = map;
	exports.ap = ap;
	exports.chain = chain;
	exports.reduce = reduce;
	exports.alt = alt;
	exports.sequence = sequence;
	exports.extend = extend;
	exports.getSetoid = getSetoid;
	exports.getOrd = getOrd;
	exports.getSemigroup = getSemigroup;
	exports.getMonoid = getMonoid;
	
	var _HKT = __webpack_require__(3);
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var Identity = function Identity() {
	  _classCallCheck(this, Identity);
	};
	
	function prj(fa) {
	  return fa;
	}
	
	function inj(a) {
	  return a;
	}
	
	function id(a) {
	  return a;
	}
	
	function map(f, fa) {
	  return inj(f(prj(fa)));
	}
	
	function ap(fab, fa) {
	  return map(prj(fab), fa);
	}
	
	var of = exports.of = inj;
	
	function chain(f, fa) {
	  return f(prj(fa));
	}
	
	function reduce(f, a, fb) {
	  return f(a, prj(fb));
	}
	
	function alt(fx, fy) {
	  // eslint-disable-line no-unused-vars
	  return fx;
	}
	
	function sequence(applicative, tfa) {
	  return applicative.map(of, prj(tfa));
	}
	
	function extend(f, ea) {
	  return of(f(ea));
	}
	
	var extract = exports.extract = prj;
	
	function getSetoid(setoid) {
	  return {
	    equals: function equals(fx, fy) {
	      return setoid.equals(prj(fx), prj(fy));
	    }
	  };
	}
	
	function getOrd(ord) {
	  return {
	    equals: getSetoid(ord).equals,
	    compare: function compare(fx, fy) {
	      return ord.compare(prj(fx), prj(fy));
	    }
	  };
	}
	
	function getSemigroup(semigroup) {
	  return {
	    concat: function concat(fx, fy) {
	      return inj(semigroup.concat(prj(fx), prj(fy)));
	    }
	  };
	}
	
	function getMonoid(monoid) {
	  return {
	    concat: getSemigroup(monoid).concat,
	    empty: function empty() {
	      return inj(monoid.empty());
	    }
	  };
	}
	
	if (false) {
	  // eslint-disable-line
	  ({
	    map: map,
	    ap: ap,
	    of: of,
	    chain: chain,
	    reduce: reduce,
	    alt: alt,
	    sequence: sequence,
	    extend: extend,
	    extract: extract
	  });
	}

/***/ }
/******/ ]);
//# sourceMappingURL=index.js.map