var path = require('path');
module.exports = {
  entry: {
    app: ['./index.js']
  },
  devtool: 'source-map',
  output: {
    path: path.resolve(__dirname, 'transpiled'),
    filename: 'index.js',
    sourceMapFilename: '[file].map'
  },
  module: {
    loaders: [
      {
        loader: 'babel',
        test: /\.js$/,
        include: [
          path.resolve(__dirname, './node_modules/flow-static-land/'),
          path.resolve(__dirname, './')
        ]
      }
    ]
  }
};
